
CREATE TABLE eWebOffice_T_Bookmark (
	D_ID Number Primary Key,
	D_BookmarkName Varchar2(100),
	D_BookmarkDesc Varchar2(100),
	D_BookmarkText Varchar2(4000) 
);

CREATE TABLE eWebOffice_T_Document (
	D_ID Number Primary Key,
	D_RecordID Varchar2(30),
	D_Subject Varchar2(250) ,
	D_Author Varchar2(50) ,
	D_FileDate Date,
	D_FileType Varchar2(20)
);

CREATE TABLE eWebOffice_T_DocumentFile (
	D_ID  Number Primary Key,
	D_RecordID Varchar2(30),
	D_FileDate Date,
	D_FileName Varchar2(250),
	D_FileType Varchar2(20),
	D_FileSize Number,
	D_FileBody BLOB,
	D_FilePath Varchar2(250),
	D_UserName Varchar2(50),
	D_Descript Varchar2(4000) 
);


CREATE TABLE eWebOffice_T_DocumentSeal (
	D_ID Number Primary Key,
	D_RecordID Varchar2(30),
	D_UserName Varchar2(50),
	D_SealName Varchar2(100),
	D_DateTime Date,
	D_IP Varchar2(50),
	D_SealGuid Varchar2(50) 
);

CREATE TABLE eWebOffice_T_Seal (
	D_ID Number Primary Key,
	D_UserName Varchar2(50),
	D_PassWord Varchar2(50),
	D_SealName Varchar2(100),
	D_FileType Varchar2(20),
	D_FileBody BLOB,
	D_FileSize Number,
	D_FilePath Varchar2(250) ,
	D_FileDate Date
);


CREATE TABLE eWebOffice_T_TemplateBookmark (
	D_ID Number Primary Key,
	D_TemplateID Varchar2(30),
	D_BookmarkName Varchar2(100) 
); 


CREATE TABLE eWebOffice_T_TemplateFile (
	D_ID Number Primary Key,
	D_TemplateID Varchar2(30),
	D_FileDate Date,
	D_FileName Varchar2(250),
	D_FileType Varchar2(20),
	D_FileSize Number,
	D_FileBody BLOB,
	D_FilePath Varchar2(250),
	D_UserName Varchar2(50),
	D_Descript Varchar2(4000) 
); 

CREATE TABLE eWebOffice_T_VersionFile (
	D_ID Number Primary Key,
	D_RecordID Varchar2(30),
	D_FileDate Date,
	D_FileName Varchar2(250),
	D_FileType Varchar2(20),
	D_FileSize Number,
	D_FileBody BLOB,
	D_FilePath Varchar2(250),
	D_UserName Varchar2(50),
	D_Descript Varchar2(4000)
); 

Create Sequence eWebOffice_S_Bookmark;
Create Sequence eWebOffice_S_Document;
Create Sequence eWebOffice_S_DocumentFile;
Create Sequence eWebOffice_S_DocumentSeal;
Create Sequence eWebOffice_S_Seal;
Create Sequence eWebOffice_S_TemplateBookmark;
Create Sequence eWebOffice_S_TemplateFile;
Create Sequence eWebOffice_S_VersionFile;

CREATE OR REPLACE TRIGGER eWebOffice_TG_Bookmark   
BEFORE INSERT ON eWebOffice_T_Bookmark FOR EACH ROW   
BEGIN  
SELECT eWebOffice_S_Bookmark.NEXTVAL INTO :NEW.D_ID FROM DUAL;   
END;  
/

CREATE OR REPLACE TRIGGER eWebOffice_TG_Document   
BEFORE INSERT ON eWebOffice_T_Document FOR EACH ROW   
BEGIN  
SELECT eWebOffice_S_Document.NEXTVAL INTO :NEW.D_ID FROM DUAL;   
END;  
/

CREATE OR REPLACE TRIGGER eWebOffice_TG_DocumentFile   
BEFORE INSERT ON eWebOffice_T_DocumentFile FOR EACH ROW   
BEGIN  
SELECT eWebOffice_S_DocumentFile.NEXTVAL INTO :NEW.D_ID FROM DUAL;   
END;  
/

CREATE OR REPLACE TRIGGER eWebOffice_TG_DocumentSeal  
BEFORE INSERT ON eWebOffice_T_DocumentSeal FOR EACH ROW   
BEGIN  
SELECT eWebOffice_S_DocumentSeal.NEXTVAL INTO :NEW.D_ID FROM DUAL;   
END;  
/

CREATE OR REPLACE TRIGGER eWebOffice_TG_Seal
BEFORE INSERT ON eWebOffice_T_Seal FOR EACH ROW   
BEGIN  
SELECT eWebOffice_S_Seal.NEXTVAL INTO :NEW.D_ID FROM DUAL;   
END;  
/

CREATE OR REPLACE TRIGGER eWebOffice_TG_TemplateBookmark   
BEFORE INSERT ON eWebOffice_T_TemplateBookmark FOR EACH ROW   
BEGIN  
SELECT eWebOffice_S_TemplateBookmark.NEXTVAL INTO :NEW.D_ID FROM DUAL;   
END;  
/

CREATE OR REPLACE TRIGGER eWebOffice_TG_TemplateFile   
BEFORE INSERT ON eWebOffice_T_TemplateFile FOR EACH ROW   
BEGIN  
SELECT eWebOffice_S_TemplateFile.NEXTVAL INTO :NEW.D_ID FROM DUAL;   
END;  
/

CREATE OR REPLACE TRIGGER eWebOffice_TG_VersionFile  
BEFORE INSERT ON eWebOffice_T_VersionFile FOR EACH ROW   
BEGIN  
SELECT eWebOffice_S_VersionFile.NEXTVAL INTO :NEW.D_ID FROM DUAL;   
END;
/
